Summary:		Linux MD devices (Software RAID) management utility
Name:			mdadm
Version:		4.2
Release:		8%{?dist}
License:		GPLv2+
URL:			http://www.kernel.org/pub/linux/utils/raid/mdadm/
Source0:		http://www.kernel.org/pub/linux/utils/raid/mdadm/%{name}-%{version}.tar.xz
Source1:		raid-check
Source2:		mdadm-raid-check-sysconfig
Source3:		raid-check.service
Source4:		raid-check.timer
Source5:		mdmonitor.service
Source6:		mdadm_event.conf
Source7:		mdadm.conf
Source8:		mdadm.rules
Patch5000:      0001-Fix-an-uninitialized-use.patch

BuildRequires:	make systemd-rpm-macros gcc 
BuildRequires:	binutils-devel systemd-devel
Requires(post): coreutils
Requires(postun): coreutils
%{?systemd_requires}

%description 
This package provides linux MD devices (Software RAID) management utility. RAID 
devices are virtual devices created from two or more real block devices. This
allows multiple devices (typically disk drives or partitions thereof) to be 
combined into a single device to hold (for example) a single filesystem.

Currently, Linux supports LINEAR md devices, RAID0 (striping), RAID1 (mirroring),
RAID4, RAID5, RAID6, RAID10, MULTIPATH, FAULTY, and CONTAINER.

%prep
%autosetup -p1

%build
%make_build CXFLAGS="%{optflags}" LDFLAGS="%{?build_ldflags}" SYSCONFDIR="%{_sysconfdir}" mdadm mdmon
# replace udev-md-raid-assembly.rules with customization rules
cp -a %{SOURCE8} udev-md-raid-assembly.rules

%install
%make_install MANDIR=%{_mandir} BINDIR=%{_sbindir} SYSTEMD_DIR=%{_unitdir} UDEVDIR=/usr/lib/udev install install-systemd

install -D -p -m 0755 %{SOURCE1} %{buildroot}%{_sbindir}/raid-check
install -D -p -m 0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/sysconfig/raid-check
install -D -p -m 0644 %{SOURCE7} %{buildroot}%{_tmpfilesdir}/%{name}.conf

install -D -m 0644 %{SOURCE3} %{buildroot}%{_unitdir}/raid-check.service
install -D -m 0644 %{SOURCE4} %{buildroot}%{_unitdir}/raid-check.timer
install -D -m 0644 %{SOURCE5} %{buildroot}%{_unitdir}/mdmonitor.service

install -d -m 0710 %{buildroot}%{_rundir}/%{name}

%post
%systemd_post mdmonitor.service raid-check.timer
%{_bindir}/systemctl disable mdmonitor-takeover.service  >/dev/null 2>&1 || :

%preun
%systemd_preun mdmonitor.service raid-check.timer

%postun
%systemd_postun_with_restart mdmonitor.service

%files
%license COPYING
%doc mdadm.conf-example misc/*
%config(noreplace) %{_sysconfdir}/sysconfig/*
%config(noreplace) %{_tmpfilesdir}/%{name}.conf
%{_udevrulesdir}/*
%{_unitdir}/*
/usr/lib/systemd/system-shutdown/*
%dir %{_rundir}/%{name}/
%{_sbindir}/*
%{_mandir}/man*/md*

%changelog
* Sun Sep 29 2024 Xiaojie Chen <jackxjchen@tencent.com> - 4.2-8
- Fix an uninitialized use

* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.2-7
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.2-6
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.2-5
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.2-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.2-3
- Rebuilt for OpenCloudOS Stream 23

* Wed Oct 26 2022 Xiaojie Chen <jackxjchen@tencent.com> - 4.2-2
- Remove requires libreport-filesystem.

* Tue Jul 12 2022 Xiaojie Chen <jackxjchen@tencent.com> - 4.2-1
- Initial build
